local TSM = select(2, ...)
TSM = LibStub("AceAddon-3.0"):NewAddon(TSM, "TradeSkillMaster_CoolDowns", "AceEvent-3.0", "AceConsole-3.0")
local AceGUI = LibStub("AceGUI-3.0")
TSM.version = GetAddOnMetadata("TradeSkillMaster_CoolDowns", "Version")

local savedDBDefaults = { --- Default the saved variables
	factionrealm = {
		["CoolDowns"] = {
			["*"] = {
				["Name"] = nil,
				["spellID"] = 1,
				["Enabled"] = true,
				["LastChecked"] = 0 --Timing NYI
			},
		},
	},
}

local MAINPARENTFORREFRESH

function TSM:OnEnable()
	-- Register with TSMAPI
	TSM.icons = { { side = "module", desc = "TradeSkillMaster_CoolDowns", slashCommand = "CoolDowns", callback = TSM.Load , icon = "Interface\\Icons\\INV_Misc_Note_05" } } -- need new icon.
	TSM.db = LibStub:GetLibrary("AceDB-3.0"):New("TradeSkillMaster_CoolDownsDB", savedDBDefaults, true)
	TSMAPI:NewModule(TSM)	-- Can't remember why this is here.
end

function TSM:CreateItemCoolDownSV(CraftCDs) -- Creates the SV for items
	for ID,Name in pairs(CraftCDs) do
		--print(ID,Name)
		TSM.db.factionrealm["CoolDowns"][ID]["Name"] = Name -- initiate item
		TSM.db.factionrealm["CoolDowns"][ID]["spellID"] = ID	-- initiate item
	end
end

function TSM.Load(parent)
	MAINPARENTFORREFRESH = parent
	local CraftCDs = TSMAPI:ModuleAPI("Crafting", "getCDCrafts") -- Load the TSM cd crafts
	TSM:CreateItemCoolDownSV(CraftCDs) -- create SV
	
	local Checks = {				
			{
			type = "Button",
			text = "Add items to Queue",
			fullWidth = true,
			callback = function() TSM:QueueItems() end,
			},
			{
			type = "Button",
			text = "Remove items to Queue",
			fullWidth = true,
			callback = function() TSM:UnQueueItems() end,
			},
			{
			type = "Button",
			text = "Enable All",
			fullWidth = true,
			callback = function() TSM:EnableAll() end,
			},
			{
			type = "Button",
			text = "Disable All",
			fullWidth = true,
			callback = function() TSM:DisableAll() end,
			},
		}
		
	for ID,Name in pairs(CraftCDs) do -- Loop through CD's and create check boxes
		local Check = {
			type = "CheckBox",
			value = TSM.db.factionrealm["CoolDowns"][ID]["Enabled"],
			label = Name,
			fullWidth = false,
			callback = function()
				if TSM.db.factionrealm["CoolDowns"][ID]["Enabled"] == false then
					TSM.db.factionrealm["CoolDowns"][ID]["Enabled"] = true
				elseif TSM.db.factionrealm["CoolDowns"][ID]["Enabled"] == true then
					TSM.db.factionrealm["CoolDowns"][ID]["Enabled"] = false
				end
			end
		}
			
		tinsert(Checks, Check)
			
	end
		
	local page = {
		{
			type="ScrollFrame",
			layout="list",
			children=
			{
				{
				type = "InlineGroup",
				layout="flow",
				title="Tradeskillmaster Cooldowns Options etc",
				children = Checks,
			},
		},
	},
}
	
	TSMAPI:BuildPage(parent,page)
end

function TSM:EnableAll()
	local CraftCDs = TSMAPI:ModuleAPI("Crafting", "getCDCrafts")
	
	for ID,Name in pairs(CraftCDs) do
		TSM.db.factionrealm["CoolDowns"][ID]["Enabled"] = true
	end
end

function TSM:DisableAll()
	local CraftCDs = TSMAPI:ModuleAPI("Crafting", "getCDCrafts")
	
	for ID,Name in pairs(CraftCDs) do
		TSM.db.factionrealm["CoolDowns"][ID]["Enabled"] = false
	end
end

function TSM:UnQueueItems()
	local CraftCDs = TSMAPI:ModuleAPI("Crafting", "getCDCrafts")
	
	for ID,Name in pairs(CraftCDs) do
		local Enabled = TSM.db.factionrealm["CoolDowns"][ID]["Enabled"]
		if Enabled == true then
			TSMAPI:ModuleAPI("Crafting", "removeQueue", ID)
		end
	end
	if ID then
		TSM:Print("Removed selected items from the queue")
	else
		TSM:Print("No item's removed")
	end
end

function TSM:QueueItems()
	local CraftCDs = TSMAPI:ModuleAPI("Crafting", "getCDCrafts")
	
	for ID,Name in pairs(CraftCDs) do
		local Enabled = TSM.db.factionrealm["CoolDowns"][ID]["Enabled"]
		if Enabled == true then
			TSMAPI:ModuleAPI("Crafting", "addQueue", ID)
		end
	end
	if ID then
		TSM:Print("Added selected items to Queue")
	else
		TSM:Print("No item's queued")
	end
end